// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QBParser.pas' rev: 5.00

#ifndef QBParserHPP
#define QBParserHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Db.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qbparser
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TQBScanner;
class PASCALIMPLEMENTATION TQBScanner : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FExpression;
	int FPosition;
	int FExprLen;
	AnsiString FToken;
	int FLevel;
	bool FInQuote;
	char FPrevQuote;
	void __fastcall SetExpression(const AnsiString Value);
	
protected:
	virtual bool __fastcall IsAlpha(char Ch);
	virtual bool __fastcall IsDelim(char Ch);
	virtual bool __fastcall IsDigit(char Ch);
	virtual bool __fastcall IsQuote(char Ch);
	virtual bool __fastcall IsSpace(char Ch);
	virtual AnsiString __fastcall GetTokenPlus();
	virtual bool __fastcall ShouldLevelUp(char Ch);
	virtual bool __fastcall ShouldLevelDown(char Ch);
	virtual void __fastcall Init(void);
	virtual void __fastcall SetPosition(const int Value);
	
public:
	__fastcall virtual TQBScanner(void);
	virtual AnsiString __fastcall GetFirstToken();
	virtual AnsiString __fastcall GetNextToken(void) = 0 ;
	__property int Position = {read=FPosition, write=SetPosition, nodefault};
	__property AnsiString Expression = {read=FExpression, write=SetExpression};
	__property AnsiString Token = {read=FToken};
	__property AnsiString TokenPlus = {read=GetTokenPlus};
	__property int Level = {read=FLevel, nodefault};
	__property bool InQuote = {read=FInQuote, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TQBScanner(void) { }
	#pragma option pop
	
};


typedef TMetaClass*TQBScannerClass;

class DELPHICLASS EQBParserError;
class PASCALIMPLEMENTATION EQBParserError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
private:
	int FCode;
	int FLineNo;
	int FLinePos;
	AnsiString FToken;
	
public:
	__fastcall EQBParserError(int ACode, const AnsiString AToken, int ALineNo, int ALinePos);
	__property int Code = {read=FCode, nodefault};
	__property int LineNo = {read=FLineNo, nodefault};
	__property int LinePos = {read=FLinePos, nodefault};
	__property AnsiString Token = {read=FToken};
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EQBParserError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EQBParserError(int Ident)/* overload */ : Sysutils::Exception(
		Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EQBParserError(int Ident, const System::TVarRec * Args
		, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EQBParserError(const AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EQBParserError(const AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EQBParserError(int Ident, int AHelpContext)/* overload */
		 : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EQBParserError(System::PResStringRec ResStringRec
		, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(
		ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EQBParserError(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBOperator;
class PASCALIMPLEMENTATION TQBOperator : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int FCount;
	AnsiString FPrefix;
	AnsiString FRelate;
	AnsiString FCaption;
	AnsiString FName;
	AnsiString FPostfix;
	
public:
	__fastcall virtual TQBOperator(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property int Count = {read=FCount, write=FCount, nodefault};
	__property AnsiString Name = {read=FName, write=FName};
	__property AnsiString Relate = {read=FRelate, write=FRelate};
	__property AnsiString Prefix = {read=FPrefix, write=FPrefix};
	__property AnsiString Postfix = {read=FPostfix, write=FPostfix};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TQBOperator(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBOperators;
class PASCALIMPLEMENTATION TQBOperators : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TQBOperator* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, const TQBOperator* Value);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	HIDESBASE TQBOperator* __fastcall Add(void);
	HIDESBASE TQBOperator* __fastcall Insert(int Index);
	TQBOperator* __fastcall FindByName(const AnsiString AName);
	TQBOperator* __fastcall FindByCaption(const AnsiString ACaption);
	TQBOperator* __fastcall FindNearest(const AnsiString ACaption, bool &Partial);
	__property TQBOperator* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TQBOperators(TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBOperators(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TTokenKind { tkUnknown, tkKeyword, tkFunction, tkDelim, tkInteger, tkFloat, tkString, tkQuote, 
	tkSpace, tkEol, tkEnd, tkIdent, tkIdentString, tkOperation, tkComparison };
#pragma option pop

typedef Set<TTokenKind, tkUnknown, tkComparison>  TTokenKinds;

class DELPHICLASS TQBSQLScanner;
class PASCALIMPLEMENTATION TQBSQLScanner : public TQBScanner 
{
	typedef TQBScanner inherited;
	
private:
	TTokenKind FTokenKind;
	Classes::TStrings* FKeywords;
	Classes::TStrings* FFunctions;
	int FLineNo;
	int FLinePos;
	int FSpacesSkipped;
	bool FEmptyString;
	bool FQuoteIdentifiers;
	Classes::TStrings* FOperations;
	void __fastcall SetFunctions(const Classes::TStrings* Value);
	void __fastcall SetKeywords(const Classes::TStrings* Value);
	void __fastcall SetOperations(const Classes::TStrings* Value);
	
protected:
	virtual bool __fastcall IsOperation(const AnsiString S);
	virtual bool __fastcall IsComparison(char Ch);
	virtual bool __fastcall IsLegalSymbol(char Ch);
	virtual bool __fastcall IsIdentQuote(char Ch);
	virtual bool __fastcall IsIdentifier(const AnsiString S);
	virtual bool __fastcall IsInteger(const AnsiString S);
	virtual bool __fastcall IsKeyword(const AnsiString S);
	virtual bool __fastcall IsFunction(const AnsiString S);
	virtual bool __fastcall IsTerminator(char Ch, const AnsiString S, char BeginQuote, char NextChar);
	virtual AnsiString __fastcall GetTokenPlus();
	virtual char __fastcall GetIdentQuote(void);
	virtual bool __fastcall GetProcessAliases(void);
	virtual bool __fastcall GetQuoteIdentifiers(void);
	virtual char __fastcall GetStringQuote(void);
	virtual bool __fastcall NeedQuotes(const AnsiString Ident);
	virtual AnsiString __fastcall GetCommaKeywords();
	virtual AnsiString __fastcall GetCommaFunctions();
	virtual AnsiString __fastcall GetCommaOperations();
	virtual AnsiString __fastcall ProcessIdent(const AnsiString S);
	virtual void __fastcall DefineKeywords(void);
	virtual void __fastcall DefineFunctions(void);
	virtual void __fastcall DefineOperations(void);
	virtual void __fastcall Init(void);
	virtual void __fastcall SetPosition(const int Value);
	
public:
	__fastcall virtual TQBSQLScanner(void);
	__fastcall virtual ~TQBSQLScanner(void);
	virtual AnsiString __fastcall GetNextToken();
	virtual AnsiString __fastcall ProcessName(const AnsiString S);
	__property TTokenKind TokenKind = {read=FTokenKind, nodefault};
	__property Classes::TStrings* Functions = {read=FFunctions, write=SetFunctions};
	__property Classes::TStrings* Keywords = {read=FKeywords, write=SetKeywords};
	__property Classes::TStrings* Operations = {read=FOperations, write=SetOperations};
	__property AnsiString CommaFunctions = {read=GetCommaFunctions};
	__property AnsiString CommaKeywords = {read=GetCommaKeywords};
	__property AnsiString CommaOperations = {read=GetCommaOperations};
	__property int LineNo = {read=FLineNo, nodefault};
	__property int LinePos = {read=FLinePos, nodefault};
	__property bool ProcessAliases = {read=GetProcessAliases, nodefault};
	__property bool QuoteIdentifiers = {read=GetQuoteIdentifiers, write=FQuoteIdentifiers, nodefault};
	__property char IdentQuote = {read=GetIdentQuote, nodefault};
	__property char StringQuote = {read=GetStringQuote, nodefault};
	__property int SpacesSkipped = {read=FSpacesSkipped, nodefault};
};


class DELPHICLASS TQBCollectionItem;
class DELPHICLASS TQBSelectParser;
#pragma option push -b-
enum TQBSelectState { ssBegin, ssError, ssEnd, ssSelect, ssFieldDefs, ssInto, ssFrom, ssTableDefs, ssWhere, 
	ssGroupBy, ssHaving, ssOrderBy, ssAppendix };
#pragma option pop

class DELPHICLASS TQBTableDefs;
class DELPHICLASS TQBCollection;
class PASCALIMPLEMENTATION TQBCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TQBSelectParser* FParser;
	TQBCollectionItem* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, const TQBCollectionItem* Value);
	
protected:
	virtual void __fastcall SetParser(const TQBSelectParser* Value);
	
public:
	HIDESBASE TQBCollectionItem* __fastcall Add(void);
	HIDESBASE TQBCollectionItem* __fastcall Insert(int Index);
	__property TQBCollectionItem* Items[int Index] = {read=GetItems, write=SetItems};
	__property TQBSelectParser* Parser = {read=FParser, write=SetParser};
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TQBCollection(TMetaClass* ItemClass) : Classes::TCollection(
		ItemClass) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBCollection(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBTableDef;
class DELPHICLASS TQBFieldDef;
class PASCALIMPLEMENTATION TQBTableDefs : public TQBCollection 
{
	typedef TQBCollection inherited;
	
private:
	HIDESBASE TQBTableDef* __fastcall GetItems(int Index);
	HIDESBASE void __fastcall SetItems(int Index, const TQBTableDef* Value);
	bool __fastcall IsTableJoined(TQBTableDef* TableDef);
	int __fastcall GetFieldCount(void);
	TQBFieldDef* __fastcall GetFieldDefs(int AbsIndex);
	AnsiString __fastcall GetUniqueAlias(const AnsiString FieldAlias, bool Force);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	HIDESBASE TQBTableDef* __fastcall Add(void);
	HIDESBASE TQBTableDef* __fastcall Insert(int Index);
	TQBTableDef* __fastcall FindByAlias(const AnsiString Alias);
	TQBTableDef* __fastcall FindByName(const AnsiString Name);
	virtual void __fastcall EndUpdate(void);
	void __fastcall UpdateFieldAliases(void);
	void __fastcall UpdateJoins(void);
	void __fastcall UpdateTableAlias(const AnsiString Alias, const AnsiString NewAlias);
	__property TQBTableDef* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property int FieldCount = {read=GetFieldCount, nodefault};
	__property TQBFieldDef* FieldDefs[int AbsIndex] = {read=GetFieldDefs};
	__property AnsiString Script = {read=GetScript};
public:
	#pragma option push -w-inl
	/* TCollection.Create */ inline __fastcall TQBTableDefs(TMetaClass* ItemClass) : TQBCollection(ItemClass
		) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBTableDefs(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBCriterions;
#pragma option push -b-
enum TQBCriterionFilter { cfAll, cfAny, cfNone, cfNotAll };
#pragma option pop

class DELPHICLASS TQBCriterion;
class PASCALIMPLEMENTATION TQBCriterions : public TQBCollection 
{
	typedef TQBCollection inherited;
	
private:
	TQBCriterionFilter FFilter;
	Classes::TPersistent* FParent;
	HIDESBASE TQBCriterion* __fastcall GetItems(int Index);
	HIDESBASE void __fastcall SetItems(int Index, const TQBCriterion* Value);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	__fastcall virtual TQBCriterions(Classes::TPersistent* AParent, TMetaClass* ItemClass);
	HIDESBASE TQBCriterion* __fastcall Add(void);
	HIDESBASE TQBCriterion* __fastcall Insert(int Index);
	__property TQBCriterion* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property TQBCriterionFilter Filter = {read=FFilter, write=FFilter, nodefault};
	__property Classes::TPersistent* Parent = {read=FParent};
	__property AnsiString Script = {read=GetScript};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBCriterions(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBOrderByItems;
class DELPHICLASS TQBStringList;
class PASCALIMPLEMENTATION TQBStringList : public Classes::TStringList 
{
	typedef Classes::TStringList inherited;
	
private:
	TQBSelectParser* FParser;
	
protected:
	AnsiString __fastcall ProcessName(const AnsiString S);
	
public:
	__fastcall TQBStringList(TQBSelectParser* AParser);
	__property TQBSelectParser* Parser = {read=FParser};
public:
	#pragma option push -w-inl
	/* TStringList.Destroy */ inline __fastcall virtual ~TQBStringList(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TQBOrderKind { okAsc, okDesc };
#pragma option pop

class PASCALIMPLEMENTATION TQBOrderByItems : public TQBStringList 
{
	typedef TQBStringList inherited;
	
private:
	Classes::TList* FOrders;
	TQBOrderKind __fastcall GetOrders(int Index);
	void __fastcall SetOrders(int Index, const TQBOrderKind Value);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	__fastcall TQBOrderByItems(TQBSelectParser* AParser);
	__fastcall virtual ~TQBOrderByItems(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual int __fastcall Add(const AnsiString S);
	int __fastcall AddOrdered(const AnsiString S, TQBOrderKind OrderKind);
	virtual void __fastcall Clear(void);
	virtual void __fastcall Delete(int Index);
	__property TQBOrderKind Orders[int Index] = {read=GetOrders, write=SetOrders};
	__property AnsiString Script = {read=GetScript};
};


class DELPHICLASS TQBGroupByItems;
class PASCALIMPLEMENTATION TQBGroupByItems : public TQBStringList 
{
	typedef TQBStringList inherited;
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	__property AnsiString Script = {read=GetScript};
public:
	#pragma option push -w-inl
	/* TQBStringList.Create */ inline __fastcall TQBGroupByItems(TQBSelectParser* AParser) : TQBStringList(
		AParser) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TStringList.Destroy */ inline __fastcall virtual ~TQBGroupByItems(void) { }
	#pragma option pop
	
};


typedef void __fastcall (__closure *TQBParserErrorEvent)(System::TObject* Sender, const AnsiString ErrorMsg
	, const AnsiString Token, int LineNo, int LinePos);

class DELPHICLASS TQBScriptFormat;
#pragma option push -b-
enum TQBFormatMode { qfmAsIs, qfmUpperCase, qfmLowerCase, qfmFirstUpper };
#pragma option pop

class PASCALIMPLEMENTATION TQBScriptFormat : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TQBFormatMode FKeywordsFormat;
	TQBFormatMode FFunctionsFormat;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TQBFormatMode FunctionsFormat = {read=FFunctionsFormat, write=FFunctionsFormat, default=0
		};
	__property TQBFormatMode KeywordsFormat = {read=FKeywordsFormat, write=FKeywordsFormat, default=0};
		
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TQBScriptFormat(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TQBScriptFormat(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


class DELPHICLASS TQBFunctionDef;
class PASCALIMPLEMENTATION TQBSelectParser : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TQBSQLScanner* FScanner;
	bool FSuccess;
	TQBSelectState FState;
	TQBTableDefs* FTableDefs;
	TQBCriterions* FWhereItems;
	TQBOrderByItems* FOrderByItems;
	TQBGroupByItems* FGroupByItems;
	TQBCriterions* FHavingItems;
	Classes::TStrings* FAggregates;
	TQBOperators* FOperators;
	bool FDistinct;
	AnsiString FLastTableName;
	AnsiString FLastTableAlias;
	TQBParserErrorEvent FOnError;
	TQBScriptFormat* FScriptFormat;
	void __fastcall SetExpression(const AnsiString Value);
	void __fastcall SetTableDefs(const TQBTableDefs* Value);
	void __fastcall SetWhereItems(const TQBCriterions* Value);
	void __fastcall SetGroupByItems(const TQBGroupByItems* Value);
	void __fastcall SetOrderByItems(const TQBOrderByItems* Value);
	void __fastcall SetHavingItems(const TQBCriterions* Value);
	void __fastcall SetAggregates(const Classes::TStrings* Value);
	void __fastcall SetOperators(const TQBOperators* Value);
	void __fastcall SetScriptFormat(const TQBScriptFormat* Value);
	
protected:
	virtual TQBSQLScanner* __fastcall CreateScanner(void);
	virtual TQBTableDefs* __fastcall CreateTableDefs(void);
	virtual TQBCriterions* __fastcall CreateWhereItems(void);
	virtual TQBCriterions* __fastcall CreateHavingItems(void);
	virtual AnsiString __fastcall GetCommaAggregates();
	virtual AnsiString __fastcall GetExpression();
	virtual bool __fastcall IsJoinDef(const AnsiString Token);
	virtual void __fastcall DefineAggregates(void);
	virtual void __fastcall DefineOperators(void);
	virtual void __fastcall DoParse(void);
	virtual void __fastcall DoParseBegin(void);
	virtual void __fastcall DoParseSelectClause(void);
	virtual void __fastcall DoParseIntoClause(void);
	virtual void __fastcall DoParseFieldDef(void);
	virtual void __fastcall DoParseFieldDefs(void);
	virtual void __fastcall DoParseFromClause(void);
	virtual void __fastcall DoParseTableDef(void);
	virtual void __fastcall DoParseProcParams(void);
	virtual void __fastcall DoParseJoinDef(void);
	virtual void __fastcall DoParseTableDefs(void);
	virtual void __fastcall DoParseWhereClause(void);
	virtual void __fastcall DoParseGroupByClause(void);
	virtual void __fastcall DoParseHavingClause(void);
	virtual void __fastcall DoParseOrderByClause(void);
	virtual void __fastcall DoParseAppendix(void);
	virtual void __fastcall DoParseCriterions(TQBCriterions* Criterions);
	virtual void __fastcall DoParseExpression(TQBFunctionDef* Destination, TQBTableDef* &TableDef, TTokenKinds 
		Terminators, const AnsiString AllowedTokens, bool FullIdents);
	virtual void __fastcall ProcessError(const AnsiString Token, int LineNo, int LinePos);
	virtual bool __fastcall GetDistinct(void);
	virtual void __fastcall SetDistinct(const bool Value);
	
public:
	__fastcall virtual TQBSelectParser(void);
	__fastcall virtual ~TQBSelectParser(void);
	AnsiString __fastcall ProcessKeyword(const AnsiString S);
	AnsiString __fastcall ProcessFunction(const AnsiString S);
	virtual void __fastcall Clear(void);
	__property bool Distinct = {read=GetDistinct, write=SetDistinct, nodefault};
	__property AnsiString Expression = {read=GetExpression, write=SetExpression};
	__property TQBSQLScanner* Scanner = {read=FScanner};
	__property TQBSelectState State = {read=FState, write=FState, nodefault};
	__property bool Success = {read=FSuccess, nodefault};
	__property Classes::TStrings* Aggregates = {read=FAggregates, write=SetAggregates};
	__property TQBOperators* Operators = {read=FOperators, write=SetOperators};
	__property AnsiString CommaAggregates = {read=GetCommaAggregates};
	__property TQBTableDefs* TableDefs = {read=FTableDefs, write=SetTableDefs};
	__property TQBCriterions* WhereItems = {read=FWhereItems, write=SetWhereItems};
	__property TQBGroupByItems* GroupByItems = {read=FGroupByItems, write=SetGroupByItems};
	__property TQBCriterions* HavingItems = {read=FHavingItems, write=SetHavingItems};
	__property TQBOrderByItems* OrderByItems = {read=FOrderByItems, write=SetOrderByItems};
	__property TQBScriptFormat* ScriptFormat = {read=FScriptFormat, write=SetScriptFormat};
	__property TQBParserErrorEvent OnError = {read=FOnError, write=FOnError};
};


class PASCALIMPLEMENTATION TQBCollectionItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TQBSelectParser* FParser;
	
protected:
	virtual void __fastcall SetParser(const TQBSelectParser* Value);
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	AnsiString __fastcall ProcessName(const AnsiString S);
	AnsiString __fastcall ProcessFunction(const AnsiString S);
	AnsiString __fastcall ProcessKeyword(const AnsiString S);
	__property TQBSelectParser* Parser = {read=FParser, write=SetParser};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TQBCollectionItem(Classes::TCollection* Collection
		) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TQBCollectionItem(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TQBFunctionKind { fkUnknown, fkFunction, fkIdentifier, fkInteger, fkFloat, fkString, fkExpression 
	};
#pragma option pop

class DELPHICLASS TQBFunctionDefs;
class PASCALIMPLEMENTATION TQBFunctionDefs : public TQBCollection 
{
	typedef TQBCollection inherited;
	
private:
	Classes::TPersistent* FParent;
	HIDESBASE TQBFunctionDef* __fastcall GetItems(int Index);
	HIDESBASE void __fastcall SetItems(int Index, const TQBFunctionDef* Value);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	__fastcall virtual TQBFunctionDefs(Classes::TPersistent* AParent, TMetaClass* ItemClass);
	HIDESBASE TQBFunctionDef* __fastcall Add(void);
	HIDESBASE TQBFunctionDef* __fastcall Insert(int Index);
	__property TQBFunctionDef* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property Classes::TPersistent* Parent = {read=FParent};
	__property AnsiString Script = {read=GetScript};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBFunctionDefs(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TQBFunctionDef : public TQBCollectionItem 
{
	typedef TQBCollectionItem inherited;
	
private:
	AnsiString FName;
	TQBFunctionDefs* FArguments;
	TQBFunctionKind FKind;
	void __fastcall SetArguments(const TQBFunctionDefs* Value);
	
protected:
	virtual TQBFunctionDefs* __fastcall CreateArguments(void);
	virtual AnsiString __fastcall GetScript();
	virtual void __fastcall SetName(const AnsiString Value);
	virtual void __fastcall SetKind(const TQBFunctionKind Value);
	virtual void __fastcall SetParser(const TQBSelectParser* Value);
	
public:
	__fastcall virtual TQBFunctionDef(Classes::TCollection* Collection);
	__fastcall virtual ~TQBFunctionDef(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Clear(void);
	__property TQBFunctionDefs* Arguments = {read=FArguments, write=SetArguments};
	__property TQBFunctionKind Kind = {read=FKind, write=SetKind, nodefault};
	__property AnsiString Name = {read=FName, write=SetName};
	__property AnsiString Script = {read=GetScript};
};


class PASCALIMPLEMENTATION TQBFieldDef : public TQBFunctionDef 
{
	typedef TQBFunctionDef inherited;
	
private:
	AnsiString FAlias;
	int FAbsIndex;
	Db::TParamType FScope;
	AnsiString __fastcall GetTableAlias();
	
protected:
	virtual AnsiString __fastcall GetScript();
	virtual AnsiString __fastcall GenerateAlias(const AnsiString AName, bool Force);
	virtual void __fastcall SetKind(const TQBFunctionKind Value);
	virtual void __fastcall SetName(const AnsiString Value);
	
public:
	__fastcall virtual TQBFieldDef(Classes::TCollection* Collection);
	__fastcall virtual ~TQBFieldDef(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall Clear(void);
	AnsiString __fastcall ProcessAlias(const AnsiString S);
	__property int AbsIndex = {read=FAbsIndex, nodefault};
	__property AnsiString Alias = {read=FAlias, write=FAlias};
	__property Db::TParamType Scope = {read=FScope, write=FScope, nodefault};
	__property AnsiString TableAlias = {read=GetTableAlias};
};


class DELPHICLASS TQBFieldDefs;
class PASCALIMPLEMENTATION TQBFieldDefs : public TQBFunctionDefs 
{
	typedef TQBFunctionDefs inherited;
	
private:
	HIDESBASE TQBFieldDef* __fastcall GetItems(int Index);
	HIDESBASE void __fastcall SetItems(int Index, const TQBFieldDef* Value);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	HIDESBASE TQBFieldDef* __fastcall Add(void);
	HIDESBASE TQBFieldDef* __fastcall Insert(int Index);
	TQBFieldDef* __fastcall FindByAlias(const AnsiString Alias);
	TQBFieldDef* __fastcall FindByName(const AnsiString Name);
	__property TQBFieldDef* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
public:
	#pragma option push -w-inl
	/* TQBFunctionDefs.Create */ inline __fastcall virtual TQBFieldDefs(Classes::TPersistent* AParent, 
		TMetaClass* ItemClass) : TQBFunctionDefs(AParent, ItemClass) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBFieldDefs(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TQBJoinKind { qbjInnerJoin, qbjLOuterJoin, qbjROuterJoin, qbjFOuterJoin };
#pragma option pop

class DELPHICLASS TQBJoinDef;
class PASCALIMPLEMENTATION TQBJoinDef : public TQBCollectionItem 
{
	typedef TQBCollectionItem inherited;
	
private:
	AnsiString FOperator;
	TQBJoinKind FKind;
	AnsiString FLinkedField;
	AnsiString FLinkedTable;
	AnsiString FFieldName;
	TQBTableDef* __fastcall GetTableDef(void);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	__fastcall virtual TQBJoinDef(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TQBJoinKind Kind = {read=FKind, write=FKind, nodefault};
	__property TQBTableDef* TableDef = {read=GetTableDef};
	__property AnsiString FieldName = {read=FFieldName, write=FFieldName};
	__property AnsiString LinkedTable = {read=FLinkedTable, write=FLinkedTable};
	__property AnsiString LinkedField = {read=FLinkedField, write=FLinkedField};
	__property AnsiString Operator = {read=FOperator, write=FOperator};
	__property AnsiString Script = {read=GetScript};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TQBJoinDef(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBJoinDefs;
class PASCALIMPLEMENTATION TQBJoinDefs : public TQBCollection 
{
	typedef TQBCollection inherited;
	
private:
	TQBTableDef* FTableDef;
	HIDESBASE TQBJoinDef* __fastcall GetItems(int Index);
	HIDESBASE void __fastcall SetItems(int Index, const TQBJoinDef* Value);
	
protected:
	virtual AnsiString __fastcall GetScript();
	
public:
	__fastcall TQBJoinDefs(TQBTableDef* ATableDef, TMetaClass* ItemClass);
	HIDESBASE TQBJoinDef* __fastcall Add(void);
	HIDESBASE TQBJoinDef* __fastcall Insert(int Index);
	TQBJoinDef* __fastcall Find(const AnsiString FieldName, const AnsiString LinkedTable, const AnsiString 
		LinkedField);
	__property TQBJoinDef* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property AnsiString Script = {read=GetScript};
	__property TQBTableDef* TableDef = {read=FTableDef};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBJoinDefs(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TQBTableDefType { qttTable, qttStoredProc };
#pragma option pop

class PASCALIMPLEMENTATION TQBTableDef : public TQBCollectionItem 
{
	typedef TQBCollectionItem inherited;
	
private:
	AnsiString FAlias;
	TQBFieldDefs* FFieldDefs;
	TQBJoinDefs* FJoinDefs;
	AnsiString FName;
	TQBTableDefType FTableDefType;
	void __fastcall SetFieldDefs(const TQBFieldDefs* Value);
	void __fastcall SetJoinDefs(const TQBJoinDefs* Value);
	void __fastcall SetName(const AnsiString Value);
	void __fastcall SetAlias(const AnsiString Value);
	
protected:
	virtual TQBFieldDefs* __fastcall CreateFieldDefs(void);
	virtual TQBJoinDefs* __fastcall CreateJoinDefs(void);
	virtual AnsiString __fastcall GetScript();
	virtual void __fastcall SetParser(const TQBSelectParser* Value);
	
public:
	__fastcall virtual TQBTableDef(Classes::TCollection* Collection);
	__fastcall virtual ~TQBTableDef(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	AnsiString __fastcall ProcessAlias(const AnsiString S);
	__property AnsiString Alias = {read=FAlias, write=SetAlias};
	__property TQBFieldDefs* FieldDefs = {read=FFieldDefs, write=SetFieldDefs};
	__property TQBJoinDefs* JoinDefs = {read=FJoinDefs, write=SetJoinDefs};
	__property AnsiString Script = {read=GetScript};
	__property AnsiString Name = {read=FName, write=SetName};
	__property TQBTableDefType TableDefType = {read=FTableDefType, write=FTableDefType, nodefault};
};


class PASCALIMPLEMENTATION TQBCriterion : public TQBCollectionItem 
{
	typedef TQBCollectionItem inherited;
	
private:
	TQBCriterions* FSubItems;
	AnsiString FOperator;
	TQBFunctionDefs* FRightSide;
	TQBFunctionDef* FLeftSide;
	void __fastcall SetSubItems(const TQBCriterions* Value);
	void __fastcall SetLeftSide(const TQBFunctionDef* Value);
	void __fastcall SetRightSide(const TQBFunctionDefs* Value);
	
protected:
	TQBCriterions* __fastcall CreateSubItems(void);
	virtual AnsiString __fastcall GetScript();
	virtual void __fastcall SetParser(const TQBSelectParser* Value);
	
public:
	__fastcall virtual TQBCriterion(Classes::TCollection* Collection);
	__fastcall virtual ~TQBCriterion(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property TQBFunctionDef* LeftSide = {read=FLeftSide, write=SetLeftSide};
	__property AnsiString Operator = {read=FOperator, write=FOperator};
	__property TQBFunctionDefs* RightSide = {read=FRightSide, write=SetRightSide};
	__property TQBCriterions* SubItems = {read=FSubItems, write=SetSubItems};
	__property AnsiString Script = {read=GetScript};
};


class DELPHICLASS TQBWhereItem;
class PASCALIMPLEMENTATION TQBWhereItem : public TQBCriterion 
{
	typedef TQBCriterion inherited;
	
protected:
	HIDESBASE TQBCriterions* __fastcall CreateSubItems(void);
public:
	#pragma option push -w-inl
	/* TQBCriterion.Create */ inline __fastcall virtual TQBWhereItem(Classes::TCollection* Collection) : 
		TQBCriterion(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TQBCriterion.Destroy */ inline __fastcall virtual ~TQBWhereItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBWhereItems;
class PASCALIMPLEMENTATION TQBWhereItems : public TQBCriterions 
{
	typedef TQBCriterions inherited;
	
protected:
	virtual AnsiString __fastcall GetScript();
public:
	#pragma option push -w-inl
	/* TQBCriterions.Create */ inline __fastcall virtual TQBWhereItems(Classes::TPersistent* AParent, TMetaClass* 
		ItemClass) : TQBCriterions(AParent, ItemClass) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBWhereItems(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBHavingItem;
class PASCALIMPLEMENTATION TQBHavingItem : public TQBCriterion 
{
	typedef TQBCriterion inherited;
	
protected:
	HIDESBASE TQBCriterions* __fastcall CreateSubItems(void);
public:
	#pragma option push -w-inl
	/* TQBCriterion.Create */ inline __fastcall virtual TQBHavingItem(Classes::TCollection* Collection)
		 : TQBCriterion(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TQBCriterion.Destroy */ inline __fastcall virtual ~TQBHavingItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQBHavingItems;
class PASCALIMPLEMENTATION TQBHavingItems : public TQBCriterions 
{
	typedef TQBCriterions inherited;
	
protected:
	virtual AnsiString __fastcall GetScript();
public:
	#pragma option push -w-inl
	/* TQBCriterions.Create */ inline __fastcall virtual TQBHavingItems(Classes::TPersistent* AParent, 
		TMetaClass* ItemClass) : TQBCriterions(AParent, ItemClass) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TQBHavingItems(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
#define sAlias "FIELD_"
#define EOL "\r\n"
static const Shortint sqleInvalidToken = 0x1;
static const Shortint sqleUnexpectedEnd = 0x2;
static const Shortint sqleUnterminatedString = 0x3;
#define SQLKeywords "SELECT,DISTINCT,INTO,FROM,WHERE,GROUP,BY,HAVING,ORDER,ASC,"\
	"DESC,AS,LEFT,RIGHT,FULL,INNER,OUTER,JOIN,ON,AND,OR,NOT"
#define SQLFunctions "SUM,MIN,MAX,AVG,COUNT"
#define SQLAggregates "SUM,MIN,MAX,AVG,COUNT"
#define SQLOperations "+,-,*,/"
extern PACKAGE AnsiString __fastcall GetFilterAsString(TQBCriterionFilter Filter);

}	/* namespace Qbparser */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qbparser;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QBParser
